program Prec
  use sep
  use bound
  use io_mod
  use polydiv

  implicit none
  integer                               :: n2, nd, m1, niter, meth, filt, if
  real,    dimension (:),   allocatable :: model,data
  type( filter)                         :: aa
  real                                  :: o1, d1, eps
  logical :: adj,add 
 
  call sep_init ()
  ! parameters
  call set_no_putch()
  call from_param ("filter", filt)
  call from_param("add",add,.false.)
  call from_param("adj",adj,.false.)

  ! create model
  call auxinout("data")
  call auxinout("model")
  call from_aux ("model","n1", m1)
  allocate (data (m1))
  allocate (model (m1))

  call read(adj,add,model,data)
  call allocatehelix (aa, filt)
  call boundn ((/ m1 /), (/ m1 /), (/ filt /), aa)
  select case (filt)
  case (1)
     aa%flt = -1.
     aa%lag = 1
  case (2)
     aa%flt = (/  -1.858735,      0.8680543  /) !(/ -2., 1. /)
     aa%lag = (/ 1, 2 /)
  end select



  call polydiv_init( size(model), aa)
  n2=polydiv_lop(adj,add,model,data)

  call write(adj,add,model,data)

end program 


